Unit uVrtDemo;

Interface

Uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, Db, DBTables, uCVrtGrd, uVrtGrid, ExtCtrls, ComCtrls, DBCtrls,
    Buttons, TypInfo, Menus;

Type
    TForm1 = Class(TForm)
        Panel1 : TPanel;
        Label1 : TLabel;
        cmbDatabase : TComboBox;
        Label2 : TLabel;
        cmbTable : TComboBox;
        tblTable : TTable;
        dsTable : TDataSource;
        PageControl1 : TPageControl;
        tabGrid : TTabSheet;
        tabProperties : TTabSheet;
        grdTable : TVerticalGrid;
        Panel2 : TPanel;
        DBNavigator1 : TDBNavigator;
        Panel3 : TPanel;
        grdProperty : TVerticalGrid;
        Panel4 : TPanel;
        Label3 : TLabel;
        btnCancel : TSpeedButton;
        btnSave : TSpeedButton;
        btnAdd : TBitBtn;
        btnDelete : TBitBtn;
        memPickList : TMemo;
        TabSheet1 : TTabSheet;
        StaticText1 : TStaticText;
        StaticText2 : TStaticText;
        StaticText3 : TStaticText;
        StaticText4 : TStaticText;
        StaticText5 : TStaticText;
        Procedure cmbDatabaseDropDown(Sender : TObject);
        Procedure cmbTableDropDown(Sender : TObject);
        Procedure Panel1Resize(Sender : TObject);
        Procedure cmbDatabaseChange(Sender : TObject);
        Procedure cmbTableChange(Sender : TObject);
        Procedure grdPropertyAlignmentGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyAlignmentSetText(Sender : TObject; ARow : Integer;
            Modified : Boolean; PickList : TStrings; Const Value : Variant);
        Procedure grdPropertyButtonStyleGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyButtonStyleSetText(Sender : TObject; ARow : Integer;
            Modified : Boolean; PickList : TStrings; Const Value : Variant);
        Procedure grdPropertyDropDownRowsGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyDropDownRowsSetText(Sender : TObject; ARow : Integer;
            Modified : Boolean; PickList : TStrings; Const Value : Variant);
        Procedure grdPropertyEditMaskGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyEditMaskSetText(Sender : TObject; ARow : Integer;
            Modified : Boolean; PickList : TStrings; Const Value : Variant);
        Procedure grdPropertyFieldNameGetEditText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyFieldNameSetText(Sender : TObject; ARow : Integer;
            Modified : Boolean; PickList : TStrings; Const Value : Variant);
        Procedure grdPropertyFieldNameValidate(Sender : TObject; ARow : Integer;
            PickList : TStrings; Var Value : Variant; Var Accept : Boolean);
        Procedure grdPropertyFieldNameGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyReadOnlyGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyReadOnlySetText(Sender : TObject; ARow : Integer;
            Modified : Boolean; PickList : TStrings; Const Value : Variant);
        Procedure grdPropertyReadOnlyValidate(Sender : TObject; ARow : Integer;
            PickList : TStrings; Var Value : Variant; Var Accept : Boolean);
        Procedure grdPropertyTextGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyTextSetText(Sender : TObject; ARow : Integer;
            Modified : Boolean; PickList : TStrings; Const Value : Variant);
        Procedure grdPropertyTitleGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure grdPropertyTitleSetText(Sender : TObject; ARow : Integer;
            Modified : Boolean; PickList : TStrings; Const Value : Variant);
        Procedure grdPropertyPickListEditButtonClick(Sender : TObject);
        Procedure btnSaveClick(Sender : TObject);
        Procedure tabPropertiesEnter(Sender : TObject);
        Procedure btnCancelClick(Sender : TObject);
        Procedure memPickListExit(Sender : TObject);
        Procedure memPickListChange(Sender : TObject);
        Procedure Panel4Resize(Sender : TObject);
        Procedure grdPropertyPickListGetText(Sender : TObject; ACol,
            ARow : Integer; PickList : TStrings; Var Value : Variant);
        Procedure btnAddClick(Sender : TObject);
        Procedure btnDeleteClick(Sender : TObject);
        Procedure grdTableEditButtonClick(Sender : TObject; ARow : Integer;
            Field : TField);
    Private
    { Private declarations }
        Procedure grdTableLoadColumns;
    Public
    { Public declarations }
    End;

Var
    Form1 : TForm1;

Implementation

{$R *.DFM}

Procedure TForm1.cmbDatabaseDropDown(Sender : TObject);
Begin
    Session.GetAliasNames(cmbDatabase.Items);
End;

Procedure TForm1.cmbTableDropDown(Sender : TObject);
Begin
    Session.GetTableNames(cmbDatabase.Text, '', True, False, cmbTable.Items);
End;

Function Min(X, Y : Variant) : Variant;
Begin
    If X < Y Then Result := X Else Result := Y;
End;

Procedure TForm1.Panel1Resize(Sender : TObject);
Begin
    cmbTable.Width := Min(Panel1.Width - 16, 220);
    cmbDatabase.Width := Min(Panel1.Width - 16, 220);
End;


Procedure TForm1.cmbDatabaseChange(Sender : TObject);
Begin
    tblTable.Active := False;
    grdTable.Reset;
    cmbTable.Text := '';
    cmbTable.Enabled := (cmbDatabase.Text <> '');
End;

Procedure TForm1.grdTableLoadColumns;
Var
    nCnt : Integer;
Begin
    tblTable.DisableControls;

    For nCnt := 0 To tblTable.FieldCount - 1 Do
    Begin
        grdTable.Columns.Add;
        With grdTable.Columns[nCnt] Do
        Begin
            FieldName := tblTable.Fields[nCnt].FieldName;
            AlignMent := taLeftJustify;
        End;
    End;

    tblTable.EnableControls;
    grdProperty.Invalidate;
End;

Procedure TForm1.cmbTableChange(Sender : TObject);
Begin
    tblTable.Active := False;
    grdTable.Reset;
    If cmbTable.Text <> '' Then
    Begin
        tblTable.DatabaseName := cmbDatabase.Text;
        tblTable.TableName := cmbTable.Text;
        tblTable.Active := True;
        grdTableLoadColumns;
    End;
End;


Procedure TForm1.grdPropertyAlignmentGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    With grdTable Do
        Value := PickList[Ord(Columns[Row].Alignment)];
End;

Procedure TForm1.grdPropertyAlignmentSetText(Sender : TObject; ARow : Integer;
    Modified : Boolean; PickList : TStrings; Const Value : Variant);
Begin
    With grdTable Do
        Columns[Row].Alignment := TAlignment(PickList.IndexOf(Value));

End;

Procedure TForm1.grdPropertyButtonStyleGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    With grdTable Do
        Value := PickList[Ord(Columns[Row].ButtonStyle)];
End;

Procedure TForm1.grdPropertyButtonStyleSetText(Sender : TObject; ARow : Integer;
    Modified : Boolean; PickList : TStrings; Const Value : Variant);
Begin
    With grdTable Do
        Columns[Row].ButtonStyle := TColumnButtonStyle(PickList.IndexOf(Value));
End;

Procedure TForm1.grdPropertyDropDownRowsGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    With grdTable Do
        Value := Columns[Row].DropDownRows;
End;

Procedure TForm1.grdPropertyDropDownRowsSetText(Sender : TObject; ARow : Integer;
    Modified : Boolean; PickList : TStrings; Const Value : Variant);
Begin
    With grdTable Do
        Columns[Row].DropDownRows := Value

     { Note that the new value is set in the OnSetText event which is called once
       only after the editing is done and not on every keystroke as in the OnSetEditText
       event }
End;

Procedure TForm1.grdPropertyEditMaskGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    With grdTable Do
        Value := Columns[Row].EditMask;
End;

Procedure TForm1.grdPropertyEditMaskSetText(Sender : TObject; ARow : Integer;
    Modified : Boolean; PickList : TStrings; Const Value : Variant);
Begin
    With grdTable Do
        Columns[Row].EditMask := Value;
End;

Procedure TForm1.grdPropertyFieldNameGetEditText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Var
    nCnt : Integer;
Begin
    For nCnt := 0 To tblTable.FieldCount - 1 Do
    Begin
        PickList.Add(tblTable.Fields[nCnt].FieldName);
    End;

    With grdTable Do
        Value := Columns[Row].FieldName;
End;

Procedure TForm1.grdPropertyFieldNameSetText(Sender : TObject; ARow : Integer;
    Modified : Boolean; PickList : TStrings; Const Value : Variant);
Begin
    With grdTable Do
        Columns[Row].FieldName := Value;
End;

Procedure TForm1.grdPropertyFieldNameValidate(Sender : TObject;
    ARow : Integer; PickList : TStrings; Var Value : Variant;
    Var Accept : Boolean);
Begin
    Accept := (Value = '') Or (PickList.IndexOf(Value) <> -1)
End;

Procedure TForm1.grdPropertyFieldNameGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    With grdTable Do
        Value := Columns[Row].FieldName;
End;

Procedure TForm1.grdPropertyReadOnlyGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    With grdTable Do
        Value := PickList[Ord(Columns[Row].ReadOnly)];
End;

Procedure TForm1.grdPropertyReadOnlySetText(Sender : TObject; ARow : Integer;
    Modified : Boolean; PickList : TStrings; Const Value : Variant);
Begin
    With grdTable Do
        Columns[Row].ReadOnly := Boolean(PickList.IndexOf(Value));
End;

Procedure TForm1.grdPropertyReadOnlyValidate(Sender : TObject;
    ARow : Integer; PickList : TStrings; Var Value : Variant;
    Var Accept : Boolean);
Begin
    Accept := (PickList.IndexOf(Value) <> -1)
End;

Procedure TForm1.grdPropertyTextGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    With grdTable Do
        Value := Columns[Row].Text;
End;

Procedure TForm1.grdPropertyTextSetText(Sender : TObject; ARow : Integer;
    Modified : Boolean; PickList : TStrings; Const Value : Variant);
Begin
    If Modified Then
        With grdTable Do
            Columns[Row].Text := Value;

     { Check modified because "FieldName"  is Cleared if the "Text" or Public "Value"
       property is assigned }

    grdProperty.Columns['FieldName'].Refresh;

     { As shown above : The columns index can be specified as an Integer or as the
       Title of the Column - like fieldnames for datasets in Delphi 3 }

End;

Procedure TForm1.grdPropertyTitleGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    With grdTable Do
        Value := Columns[Row].Title;
End;

Procedure TForm1.grdPropertyTitleSetText(Sender : TObject; ARow : Integer;
    Modified : Boolean; PickList : TStrings; Const Value : Variant);
Begin
    With grdTable Do
        Columns[Row].Title := Value;
End;

Procedure TForm1.grdPropertyPickListEditButtonClick(Sender : TObject);
Begin
    MemPickList.Enabled := True;
    MemPickList.SetFocus;
End;

Procedure TForm1.btnSaveClick(Sender : TObject);
Begin
    With grdTable Do
        Columns[Row].PickList.Assign(memPickList.Lines);
    memPickListExit(Sender);
    grdProperty.SetFocus;
End;

Procedure TForm1.tabPropertiesEnter(Sender : TObject);
Begin
    memPickList.Visible := True;
    memPickList.Enabled := False;
    memPickList.Lines.Clear;
    With grdTable Do
        memPickList.Lines.Assign(Columns[Row].PickList);
End;

Procedure TForm1.btnCancelClick(Sender : TObject);
Begin
    memPickList.Lines.Clear;
    With grdTable Do
        memPickList.Lines.Assign(Columns[Row].PickList);
    memPickListExit(Sender);
    grdProperty.Setfocus;
End;

Procedure TForm1.memPickListExit(Sender : TObject);
Begin
    btnSave.Enabled := False;
    btnCancel.Enabled := False;
    memPickList.Enabled := False;
End;

Procedure TForm1.memPickListChange(Sender : TObject);
Begin
    btnCancel.Enabled := True;
    btnSave.Enabled := True;
End;

Procedure TForm1.Panel4Resize(Sender : TObject);
Begin
    memPickList.Width := Panel4.Width - 30;
    memPickList.Height := Panel4.Height - 70;
    btnAdd.Top := Panel4.Height - 32;
    btnDelete.Top := btnAdd.Top;
    btnSave.Left := Panel4.Width - 27;
    btnSave.Top := memPicklist.Height;
    btnCancel.Left := btnSave.Left;
    btnCancel.Top := memPicklist.Height - 32;
    btnAdd.Left := Panel4.Width - 86;
    btnDelete.Left := Panel4.Width - 174;
End;

Procedure TForm1.grdPropertyPickListGetText(Sender : TObject; ACol,
    ARow : Integer; PickList : TStrings; Var Value : Variant);
Begin
    Value := '(TStrings)'
End;

Procedure TForm1.btnAddClick(Sender : TObject);
Begin
    grdTable.Columns.Add;
End;

Procedure TForm1.btnDeleteClick(Sender : TObject);
Begin
    grdTable.Columns.Delete(grdTable.Row);
End;

Procedure TForm1.grdTableEditButtonClick(Sender : TObject; ARow : Integer;
    Field : TField);
Begin
    MessageDlg('Custom Edit behaviour implemented at Grid level', mtInformation, [mbOk], 0);
End;

End.

